<div>

    <app-grid-no-data *ngIf="!communications || communications.length === 0"
                      title="You haven’t sent an SMS or Email or added a communication note."
                      description="You can start sending SMS or Email for this patient or their contacts By click on Send SMS or Email button. You can also add a note about an conversation you had with this patient here."
    >
    </app-grid-no-data>

    <kendo-grid *ngIf="communications && communications.length > 0" [data]="gridView" [pageSize]="pageSize"
                [skip]="skip" [pageable]="true" [columnMenu]="false"
                [filterable]="true" [filter]="state.filter"
                (dataStateChange)="dataStateChange($event)" [groupable]="false"
                [reorderable]="reorder" [sortable]="{
              allowUnsort: allowUnsort,
              mode: multiple ? 'multiple' : 'single'
            }" [sort]="sort" (sortChange)="sortChange($event)" (groupChange)="groupChange($event)">

        <kendo-grid-column field="typeStr" title="Type" [width]="100">
        </kendo-grid-column>

        <kendo-grid-column field="createdDateStr" title="Date Time" [width]="180">
        </kendo-grid-column>

        <kendo-grid-column field="fromEmail" title="Sender" [width]="150">
        </kendo-grid-column>

        <kendo-grid-column field="subject" title="Subject" [width]="150">
        </kendo-grid-column>

        <kendo-grid-column *ngIf="!fromTab" field="autoDeleteDateStr" title="Auto Deleted After" [width]="150">
        </kendo-grid-column>

        <kendo-grid-column field="attachmentStr" title="Attachment" [width]="180">
            <ng-template kendoGridCellTemplate let-dataItem>
                <div class="d-flex align-items-center">
                            <span [style.color]="dataItem.communicationAttachment.length > 0 ? '#00AEEF' : ''" class="cursor-pointer" (click)="previewFile(dataItem)">
                                {{
                                    dataItem.communicationAttachment && dataItem.communicationAttachment.length > 0 ?
                                    (dataItem.communicationAttachment.length === 1 ? dataItem.communicationAttachment[0].fileName : dataItem.communicationAttachment.length + ' Files')
                                    : 'None'
                                }}
                            </span>
                </div>
            </ng-template>
        </kendo-grid-column>

        <kendo-grid-column field="statusStr" title="Status" [width]="100">
        </kendo-grid-column>

        <kendo-grid-column title="Action" [width]="80" *appAccess="moduleName; lookFor:_any">
            <ng-template kendoGridCellTemplate let-dataItems>
                <button (click)="openBulkActionPopup(dataItems, $event)"
                        class="item-setting-btn border-0 bg-transparent cursor-pointer">
                    <mat-icon class="m-0" style="color: #979797;">settings</mat-icon>
                </button>
            </ng-template>
        </kendo-grid-column>

    </kendo-grid>

</div>

<dx-popover #actionPopup class="grid-action-popup" position="top" [width]="176" [height]="'auto'"
            [shading]="false" [position]="{my: 'right top', at: 'right bottom'}">
    <div *dxTemplate="let data of 'content'">
        <button *ngIf="hasPermission(moduleName, 'E') && actionItem && actionItem.communicationType === Note" class="grid-action-popup-button text-left" (click)="doAction(EDIT)">
            <mat-icon>edit</mat-icon>
            <span>Edit</span>
        </button>
        <button *appAccess="moduleName; lookFor:'V'" class="grid-action-popup-button text-left" (click)="doAction(PREVIEW)">
            <mat-icon>visibility</mat-icon>
            <span>Preview</span>
        </button>
        <button *appAccess="moduleName; lookFor:'V'" class="grid-action-popup-button text-left" (click)="doAction(PRINT)">
            <mat-icon>print</mat-icon>
            <span>Print</span>
        </button>
        <button *ngIf="hasPermission(moduleName, 'D') && actionItem && actionItem.communicationType === Note" class="grid-action-popup-button text-left"
                (click)="doAction(DELETE)">
            <mat-icon>delete</mat-icon>
            <span>Delete</span>
        </button>
        <button *ngIf="hasPermission(moduleName, 'V') && actionItem.communicationAttachment && actionItem.communicationAttachment.length > 0" class="grid-action-popup-button text-left" (click)="doAction(DOWNLOAD)">
            <mat-icon>file_download</mat-icon>
            <span>Download</span>
        </button>
    </div>
</dx-popover>

<dx-popover #filterActionPopup class="grid-action-popup" position="top" [width]="176" [height]="'auto'"
            [shading]="false" [position]="{my: 'right top', at: 'right bottom'}">
    <div *dxTemplate="let data of 'content'">
        <button class="grid-action-popup-button text-left" (click)="filterByDate()">
            <span>Date</span>
        </button>
        <button class="grid-action-popup-button text-left" (click)="filterByType()">
            <span>Type</span>
        </button>

    </div>
</dx-popover>

<!-- DATE FILTER TEMPLATE -->
<ng-template #dateFilter>
    <div class="ac-date-filter-container" style="padding: 20px;">

        <div class="mb-2 normal_14px_22px_font" style="color: #1c1b1b;">
            Please select the date range to filter the Comm. List:
        </div>

        <mat-form-field appearance="outline" class="full-width">
            <mat-label class="disable-label">Start Date</mat-label>
            <app-date-picker icon="./assets/ic-calendar-big.png" [value]="fromDateCtrl.value" (valueChange)="onDateSelect($event, FROM_DATE)"></app-date-picker>
        </mat-form-field>

        <mat-form-field appearance="outline" class="full-width">
            <mat-label class="disable-label">End Date</mat-label>
            <app-date-picker icon="./assets/ic-calendar-big.png" [value]="toDateCtrl.value" (valueChange)="onDateSelect($event, TO_DATE)"></app-date-picker>
        </mat-form-field>

    </div>
</ng-template>

<!-- Communication Type Filter Template -->
<ng-template #typeFilter>
    <div class="comm-type-filter-container" style="padding: 20px;">

        <div class="mb-2 normal_14px_22px_font" style="color: #1c1b1b;">
            Please select the Communication Type to filter the Comm. List:
        </div>

        <div class="flex-fill" style="border: 1px solid #979797; overflow: overlay;">
            <div style="border-bottom: 1px solid rgba(0, 0, 0, 0.12); padding: 5px;">
                <mat-checkbox class="practitioner-checkbox" (change)="toggleAllType($event)"
                              value="ALL">
                    <span>Select All</span>
                </mat-checkbox>
            </div>

            <div *ngFor="let type of commTypes; let i = index;"
                 style="border-bottom: 1px solid rgba(0, 0, 0, 0.12); padding: 5px;"
                 [class.border-0]="i === commTypes.length - 1">
                <mat-checkbox class="comm-type-checkbox" (change)="toggleType($event)"
                              [value]="type.id" [checked]="selectedType.indexOf(type.id) > -1">
                    <ng-container [ngSwitch]="type.type">

                        <div *ngSwitchCase="Email">Email</div>
                        <div *ngSwitchCase="Sms">SMS</div>
                        <div *ngSwitchCase="Note">Note</div>

                    </ng-container>
                </mat-checkbox>
            </div>
        </div>

    </div>
</ng-template>
